<?php

namespace controleur;

use model\AdminModel;
use model\ArticleModel;

class AdminControleur
{
    public function __construct(){
        global $twig; // nécessaire pour utiliser variables globales
        //debut

        //on initialise un tableau d'erreur
        $dVueEreur = [];

        try {
            $action = $_REQUEST['action'] ?? null;

            switch($action) {
                //pas d'action, on réinitialise 1er appel
                case null:
                    $this->connection();
                    break;

                case 'connection':
                    $this->connection();;
                    break;
                case 'validationFormulaire':
                    $this->ValidationFormulaire($dVueEreur);
                    break;

                case 'listArticle':
                    $this->listArticle();
                    break;
                //mauvaise action
                default:
                    $dVueEreur[] = "Erreur d'appel php";
                    echo $twig->render('listArticle.html', ['dVueErreur'=>$dVueEreur,'isAdmin' => AdminModel::isAdmin()]);
                    break;
            }
        } catch (\PDOException $e) {
            //si erreur BD, pas le cas ici
            $dVueEreur[] = 'Erreur PDO : ' . $e->getMessage();
            echo $twig->render('erreur.html', ['dVueEreur' => $dVueEreur]);
        } catch (\Exception $e2) {
            $dVueEreur[] = 'Erreur : ' . $e2->getMessage();
            echo $twig->render('erreur.html', ['dVueEreur' => $dVueEreur]);
        }

        //fin
        exit(0);
    }

    public function listArticle()
    {
        global $twig;
        $articleModel = new ArticleModel();
        $dVue = [
            'data' => $articleModel->getArticles()
        ];
        echo $twig->render('listArticle.html', [
            'dVue' => $dVue,
            'isAdmin' => AdminModel::isAdmin()
        ]);
    }

    public function connection(){
        global $twig; // nécessaire pour utiliser variables globales
        if (!AdminModel::isAdmin()){
            $this->listArticle();
        }
        else {
            echo $twig->render('Connection.html');
            if (isset($_POST['username']) && isset($_POST['password'])) {
                $this->login();
            }
        }
    }

    public function login(){
        $username = $_POST['username'];
        $password = $_POST['password'];

        $adminModel = new AdminModel();
        $admin = $adminModel->connection($username, $password);

        if ($admin != null) {
            $this->listArticle();
        }
        else{
            unset($_POST['username']);
            unset($_POST['passwords']);
            $this->connection();
        }
    }
}